# on_arrival_client_api

OnArrivalClientApi - JavaScript client for on_arrival_client_api
OnArrival API service documentation
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: v1.0
- Package version: v1.0
- Build package: io.swagger.codegen.v3.generators.javascript.JavaScriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install on_arrival_client_api --save
```

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var OnArrivalClientApi = require('on_arrival_client_api');
var defaultClient = OnArrivalClientApi.ApiClient.instance;


var api = new OnArrivalClientApi.AuthorizationApi()
var body = new OnArrivalClientApi.ClientAuthRequest(); // {ClientAuthRequest} 

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.getClientToken(body, callback);
```

## Documentation for API Endpoints

All URIs are relative to *http://dev-api.onarriv.io*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*OnArrivalClientApi.AuthorizationApi* | [**getClientToken**](docs/AuthorizationApi.md#getClientToken) | **POST** /api/v1/auth/oauth/token | Get OAuth token to be used with every API transaction.                      The token expires every 1 day and                       has to be regenerated using this endpoint.
*OnArrivalClientApi.DiscoverTravelAncillariesApi* | [**getQuotationByType**](docs/DiscoverTravelAncillariesApi.md#getQuotationByType) | **POST** /api/v1/discover | Discover Ancillaries
*OnArrivalClientApi.InsuranceApi* | [**createOrder1**](docs/InsuranceApi.md#createOrder1) | **POST** /api/v1/insurance/order | Place an order for insurance
*OnArrivalClientApi.InsuranceApi* | [**getInsuranceQuote**](docs/InsuranceApi.md#getInsuranceQuote) | **POST** /api/v1/insurance/quote | Get Quote for Insurance product
*OnArrivalClientApi.VisaApi* | [**attachDocumentsToVisaOrder**](docs/VisaApi.md#attachDocumentsToVisaOrder) | **POST** /api/v1/visa/order/document | Attach document to Visa order
*OnArrivalClientApi.VisaApi* | [**cancelVisaOrder**](docs/VisaApi.md#cancelVisaOrder) | **POST** /api/v1/visa/cancel | 
*OnArrivalClientApi.VisaApi* | [**createOrder**](docs/VisaApi.md#createOrder) | **POST** /api/v1/visa/order | 
*OnArrivalClientApi.VisaApi* | [**createVisaDraftOrder**](docs/VisaApi.md#createVisaDraftOrder) | **POST** /api/v1/visa/ | Book Visa
*OnArrivalClientApi.VisaApi* | [**getVisaOrderStatus**](docs/VisaApi.md#getVisaOrderStatus) | **GET** /api/v1/visa/status | Get visa order status

## Documentation for Models

 - [OnArrivalClientApi.ActionLog](docs/ActionLog.md)
 - [OnArrivalClientApi.Address](docs/Address.md)
 - [OnArrivalClientApi.ApplicationResponse](docs/ApplicationResponse.md)
 - [OnArrivalClientApi.Attachment](docs/Attachment.md)
 - [OnArrivalClientApi.BenefitDetail](docs/BenefitDetail.md)
 - [OnArrivalClientApi.BookingDetail](docs/BookingDetail.md)
 - [OnArrivalClientApi.ClientAuthRequest](docs/ClientAuthRequest.md)
 - [OnArrivalClientApi.ClientAuthResponse](docs/ClientAuthResponse.md)
 - [OnArrivalClientApi.DateTimeAndTimeZone](docs/DateTimeAndTimeZone.md)
 - [OnArrivalClientApi.DiscoveryRequest](docs/DiscoveryRequest.md)
 - [OnArrivalClientApi.DiscoveryResponse](docs/DiscoveryResponse.md)
 - [OnArrivalClientApi.InsurancePolicy](docs/InsurancePolicy.md)
 - [OnArrivalClientApi.InsurancePolicyOrderResponse](docs/InsurancePolicyOrderResponse.md)
 - [OnArrivalClientApi.InsurancePolicyQuoteResponse](docs/InsurancePolicyQuoteResponse.md)
 - [OnArrivalClientApi.InsurancePolicyRequest](docs/InsurancePolicyRequest.md)
 - [OnArrivalClientApi.Member](docs/Member.md)
 - [OnArrivalClientApi.MemberCountValue](docs/MemberCountValue.md)
 - [OnArrivalClientApi.MemberDAO](docs/MemberDAO.md)
 - [OnArrivalClientApi.MemberDocument](docs/MemberDocument.md)
 - [OnArrivalClientApi.OriginDestination](docs/OriginDestination.md)
 - [OnArrivalClientApi.OriginDestinationCode](docs/OriginDestinationCode.md)
 - [OnArrivalClientApi.Passport](docs/Passport.md)
 - [OnArrivalClientApi.Product](docs/Product.md)
 - [OnArrivalClientApi.ProductInformation](docs/ProductInformation.md)
 - [OnArrivalClientApi.ProductMeta](docs/ProductMeta.md)
 - [OnArrivalClientApi.QuoteInsurance](docs/QuoteInsurance.md)
 - [OnArrivalClientApi.RequiredDocument](docs/RequiredDocument.md)
 - [OnArrivalClientApi.Tax](docs/Tax.md)
 - [OnArrivalClientApi.TaxDetail](docs/TaxDetail.md)
 - [OnArrivalClientApi.Trip](docs/Trip.md)
 - [OnArrivalClientApi.TripDAO](docs/TripDAO.md)
 - [OnArrivalClientApi.VisaFileUploadRequest](docs/VisaFileUploadRequest.md)
 - [OnArrivalClientApi.VisaFileUploadResponse](docs/VisaFileUploadResponse.md)
 - [OnArrivalClientApi.VisaOrder](docs/VisaOrder.md)
 - [OnArrivalClientApi.VisaProduct](docs/VisaProduct.md)
 - [OnArrivalClientApi.VisaRequest](docs/VisaRequest.md)

## Documentation for Authorization


### bearerScheme


