# OnArrivalClientApi.AuthorizationApi

All URIs are relative to *http://dev-api.onarriv.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getClientToken**](AuthorizationApi.md#getClientToken) | **POST** /api/v1/auth/oauth/token | Get OAuth token to be used with every API transaction.                      The token expires every 1 day and                       has to be regenerated using this endpoint.

<a name="getClientToken"></a>
# **getClientToken**
> ClientAuthResponse getClientToken(body)

Get OAuth token to be used with every API transaction.                      The token expires every 1 day and                       has to be regenerated using this endpoint.

Returns access token for valid AccessToken

### Example
```javascript
import {OnArrivalClientApi} from 'on_arrival_client_api';
let defaultClient = OnArrivalClientApi.ApiClient.instance;


let apiInstance = new OnArrivalClientApi.AuthorizationApi();
let body = new OnArrivalClientApi.ClientAuthRequest(); // ClientAuthRequest | 

apiInstance.getClientToken(body, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ClientAuthRequest**](ClientAuthRequest.md)|  | 

### Return type

[**ClientAuthResponse**](ClientAuthResponse.md)

### Authorization

[bearerScheme](../README.md#bearerScheme)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

