# OnArrivalClientApi.DiscoverTravelAncillariesApi

All URIs are relative to *http://dev-api.onarriv.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getQuotationByType**](DiscoverTravelAncillariesApi.md#getQuotationByType) | **POST** /api/v1/discover | Discover Ancillaries

<a name="getQuotationByType"></a>
# **getQuotationByType**
> DiscoveryResponse getQuotationByType(type, opts)

Discover Ancillaries

Returns List of Products based on ancillaries type

### Example
```javascript
import {OnArrivalClientApi} from 'on_arrival_client_api';
let defaultClient = OnArrivalClientApi.ApiClient.instance;


let apiInstance = new OnArrivalClientApi.DiscoverTravelAncillariesApi();
let type = "type_example"; // String | 
let opts = { 
  'body': new OnArrivalClientApi.DiscoveryRequest() // DiscoveryRequest | 
};
apiInstance.getQuotationByType(type, opts, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **type** | **String**|  | 
 **body** | [**DiscoveryRequest**](DiscoveryRequest.md)|  | [optional] 

### Return type

[**DiscoveryResponse**](DiscoveryResponse.md)

### Authorization

[bearerScheme](../README.md#bearerScheme)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

