# OnArrivalClientApi.InsuranceApi

All URIs are relative to *http://dev-api.onarriv.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createOrder1**](InsuranceApi.md#createOrder1) | **POST** /api/v1/insurance/order | Place an order for insurance
[**getInsuranceQuote**](InsuranceApi.md#getInsuranceQuote) | **POST** /api/v1/insurance/quote | Get Quote for Insurance product

<a name="createOrder1"></a>
# **createOrder1**
> InsurancePolicyOrderResponse createOrder1(opts)

Place an order for insurance

Returns 200 if successful

### Example
```javascript
import {OnArrivalClientApi} from 'on_arrival_client_api';
let defaultClient = OnArrivalClientApi.ApiClient.instance;


let apiInstance = new OnArrivalClientApi.InsuranceApi();
let opts = { 
  'body': new OnArrivalClientApi.InsurancePolicyRequest() // InsurancePolicyRequest | 
};
apiInstance.createOrder1(opts, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**InsurancePolicyRequest**](InsurancePolicyRequest.md)|  | [optional] 

### Return type

[**InsurancePolicyOrderResponse**](InsurancePolicyOrderResponse.md)

### Authorization

[bearerScheme](../README.md#bearerScheme)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="getInsuranceQuote"></a>
# **getInsuranceQuote**
> InsurancePolicyQuoteResponse getInsuranceQuote(opts)

Get Quote for Insurance product

Returns 200 if successful

### Example
```javascript
import {OnArrivalClientApi} from 'on_arrival_client_api';
let defaultClient = OnArrivalClientApi.ApiClient.instance;


let apiInstance = new OnArrivalClientApi.InsuranceApi();
let opts = { 
  'body': new OnArrivalClientApi.InsurancePolicyRequest() // InsurancePolicyRequest | 
};
apiInstance.getInsuranceQuote(opts, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**InsurancePolicyRequest**](InsurancePolicyRequest.md)|  | [optional] 

### Return type

[**InsurancePolicyQuoteResponse**](InsurancePolicyQuoteResponse.md)

### Authorization

[bearerScheme](../README.md#bearerScheme)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

