# OnArrivalClientApi.VisaApi

All URIs are relative to *http://dev-api.onarriv.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**attachDocumentsToVisaOrder**](VisaApi.md#attachDocumentsToVisaOrder) | **POST** /api/v1/visa/order/document | Attach document to Visa order
[**cancelVisaOrder**](VisaApi.md#cancelVisaOrder) | **POST** /api/v1/visa/cancel | 
[**createOrder**](VisaApi.md#createOrder) | **POST** /api/v1/visa/order | 
[**createVisaDraftOrder**](VisaApi.md#createVisaDraftOrder) | **POST** /api/v1/visa/ | Book Visa
[**getVisaOrderStatus**](VisaApi.md#getVisaOrderStatus) | **GET** /api/v1/visa/status | Get visa order status

<a name="attachDocumentsToVisaOrder"></a>
# **attachDocumentsToVisaOrder**
> VisaFileUploadResponse attachDocumentsToVisaOrder(opts)

Attach document to Visa order

Returns 200 if successful

### Example
```javascript
import {OnArrivalClientApi} from 'on_arrival_client_api';
let defaultClient = OnArrivalClientApi.ApiClient.instance;


let apiInstance = new OnArrivalClientApi.VisaApi();
let opts = { 
  'body': new OnArrivalClientApi.VisaFileUploadRequest() // VisaFileUploadRequest | 
};
apiInstance.attachDocumentsToVisaOrder(opts, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**VisaFileUploadRequest**](VisaFileUploadRequest.md)|  | [optional] 

### Return type

[**VisaFileUploadResponse**](VisaFileUploadResponse.md)

### Authorization

[bearerScheme](../README.md#bearerScheme)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="cancelVisaOrder"></a>
# **cancelVisaOrder**
> ApplicationResponse cancelVisaOrder(id)



### Example
```javascript
import {OnArrivalClientApi} from 'on_arrival_client_api';
let defaultClient = OnArrivalClientApi.ApiClient.instance;


let apiInstance = new OnArrivalClientApi.VisaApi();
let id = "id_example"; // String | 

apiInstance.cancelVisaOrder(id, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 

### Return type

[**ApplicationResponse**](ApplicationResponse.md)

### Authorization

[bearerScheme](../README.md#bearerScheme)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

<a name="createOrder"></a>
# **createOrder**
> ApplicationResponse createOrder(id)



### Example
```javascript
import {OnArrivalClientApi} from 'on_arrival_client_api';
let defaultClient = OnArrivalClientApi.ApiClient.instance;


let apiInstance = new OnArrivalClientApi.VisaApi();
let id = "id_example"; // String | 

apiInstance.createOrder(id, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 

### Return type

[**ApplicationResponse**](ApplicationResponse.md)

### Authorization

[bearerScheme](../README.md#bearerScheme)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

<a name="createVisaDraftOrder"></a>
# **createVisaDraftOrder**
> VisaOrder createVisaDraftOrder(opts)

Book Visa

Returns 200 if successful,visa response inside data 

### Example
```javascript
import {OnArrivalClientApi} from 'on_arrival_client_api';
let defaultClient = OnArrivalClientApi.ApiClient.instance;


let apiInstance = new OnArrivalClientApi.VisaApi();
let opts = { 
  'body': new OnArrivalClientApi.VisaRequest() // VisaRequest | 
};
apiInstance.createVisaDraftOrder(opts, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**VisaRequest**](VisaRequest.md)|  | [optional] 

### Return type

[**VisaOrder**](VisaOrder.md)

### Authorization

[bearerScheme](../README.md#bearerScheme)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="getVisaOrderStatus"></a>
# **getVisaOrderStatus**
> VisaOrder getVisaOrderStatus(bookingIdOfVisa)

Get visa order status

Returns 200 if successful

### Example
```javascript
import {OnArrivalClientApi} from 'on_arrival_client_api';
let defaultClient = OnArrivalClientApi.ApiClient.instance;


let apiInstance = new OnArrivalClientApi.VisaApi();
let bookingIdOfVisa = "bookingIdOfVisa_example"; // String | 

apiInstance.getVisaOrderStatus(bookingIdOfVisa, (error, data, response) => {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
});
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookingIdOfVisa** | **String**|  | 

### Return type

[**VisaOrder**](VisaOrder.md)

### Authorization

[bearerScheme](../README.md#bearerScheme)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, */*

