/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from "../ApiClient";
import {ApplicationResponse} from '../model/ApplicationResponse';
import {ClientAuthRequest} from '../model/ClientAuthRequest';
import {ClientAuthResponse} from '../model/ClientAuthResponse';

/**
* Authorization service.
* @module api/AuthorizationApi
* @version v1.0
*/
export class AuthorizationApi {

    /**
    * Constructs a new AuthorizationApi. 
    * @alias module:api/AuthorizationApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the getClientToken operation.
     * @callback moduleapi/AuthorizationApi~getClientTokenCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ClientAuthResponse{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get OAuth token to be used with every API transaction.                      The token expires every 1 day and                       has to be regenerated using this endpoint.
     * Returns access token for valid AccessToken
     * @param {module:model/ClientAuthRequest} body 
     * @param {module:api/AuthorizationApi~getClientTokenCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    getClientToken(body, callback) {
      
      let postBody = body;
      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling getClientToken");
      }

      let pathParams = {
        
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerScheme'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json', '*/*'];
      let returnType = ClientAuthResponse;

      return this.apiClient.callApi(
        '/api/v1/auth/oauth/token', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}