/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from "../ApiClient";
import {ApplicationResponse} from '../model/ApplicationResponse';
import {DiscoveryRequest} from '../model/DiscoveryRequest';
import {DiscoveryResponse} from '../model/DiscoveryResponse';

/**
* DiscoverTravelAncillaries service.
* @module api/DiscoverTravelAncillariesApi
* @version v1.0
*/
export class DiscoverTravelAncillariesApi {

    /**
    * Constructs a new DiscoverTravelAncillariesApi. 
    * @alias module:api/DiscoverTravelAncillariesApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the getQuotationByType operation.
     * @callback moduleapi/DiscoverTravelAncillariesApi~getQuotationByTypeCallback
     * @param {String} error Error message, if any.
     * @param {module:model/DiscoveryResponse{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Discover Ancillaries
     * Returns List of Products based on ancillaries type
     * @param {module:model/String} type 
     * @param {Object} opts Optional parameters
     * @param {module:model/DiscoveryRequest} opts.body 
     * @param {module:api/DiscoverTravelAncillariesApi~getQuotationByTypeCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    getQuotationByType(type, opts, callback) {
      opts = opts || {};
      let postBody = opts['body'];
      // verify the required parameter 'type' is set
      if (type === undefined || type === null) {
        throw new Error("Missing the required parameter 'type' when calling getQuotationByType");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'type': type
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerScheme'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json', '*/*'];
      let returnType = DiscoveryResponse;

      return this.apiClient.callApi(
        '/api/v1/discover', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}