/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from "../ApiClient";
import {ApplicationResponse} from '../model/ApplicationResponse';
import {InsurancePolicyOrderResponse} from '../model/InsurancePolicyOrderResponse';
import {InsurancePolicyQuoteResponse} from '../model/InsurancePolicyQuoteResponse';
import {InsurancePolicyRequest} from '../model/InsurancePolicyRequest';

/**
* Insurance service.
* @module api/InsuranceApi
* @version v1.0
*/
export class InsuranceApi {

    /**
    * Constructs a new InsuranceApi. 
    * @alias module:api/InsuranceApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the createOrder1 operation.
     * @callback moduleapi/InsuranceApi~createOrder1Callback
     * @param {String} error Error message, if any.
     * @param {module:model/InsurancePolicyOrderResponse{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Place an order for insurance
     * Returns 200 if successful
     * @param {Object} opts Optional parameters
     * @param {module:model/InsurancePolicyRequest} opts.body 
     * @param {module:api/InsuranceApi~createOrder1Callback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    createOrder1(opts, callback) {
      opts = opts || {};
      let postBody = opts['body'];

      let pathParams = {
        
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerScheme'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json', '*/*'];
      let returnType = InsurancePolicyOrderResponse;

      return this.apiClient.callApi(
        '/api/v1/insurance/order', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the getInsuranceQuote operation.
     * @callback moduleapi/InsuranceApi~getInsuranceQuoteCallback
     * @param {String} error Error message, if any.
     * @param {module:model/InsurancePolicyQuoteResponse{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Quote for Insurance product
     * Returns 200 if successful
     * @param {Object} opts Optional parameters
     * @param {module:model/InsurancePolicyRequest} opts.body 
     * @param {module:api/InsuranceApi~getInsuranceQuoteCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    getInsuranceQuote(opts, callback) {
      opts = opts || {};
      let postBody = opts['body'];

      let pathParams = {
        
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerScheme'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json', '*/*'];
      let returnType = InsurancePolicyQuoteResponse;

      return this.apiClient.callApi(
        '/api/v1/insurance/quote', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}