/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from "../ApiClient";
import {ApplicationResponse} from '../model/ApplicationResponse';
import {VisaFileUploadRequest} from '../model/VisaFileUploadRequest';
import {VisaFileUploadResponse} from '../model/VisaFileUploadResponse';
import {VisaOrder} from '../model/VisaOrder';
import {VisaRequest} from '../model/VisaRequest';

/**
* Visa service.
* @module api/VisaApi
* @version v1.0
*/
export class VisaApi {

    /**
    * Constructs a new VisaApi. 
    * @alias module:api/VisaApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the attachDocumentsToVisaOrder operation.
     * @callback moduleapi/VisaApi~attachDocumentsToVisaOrderCallback
     * @param {String} error Error message, if any.
     * @param {module:model/VisaFileUploadResponse{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Attach document to Visa order
     * Returns 200 if successful
     * @param {Object} opts Optional parameters
     * @param {module:model/VisaFileUploadRequest} opts.body 
     * @param {module:api/VisaApi~attachDocumentsToVisaOrderCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    attachDocumentsToVisaOrder(opts, callback) {
      opts = opts || {};
      let postBody = opts['body'];

      let pathParams = {
        
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerScheme'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json', '*/*'];
      let returnType = VisaFileUploadResponse;

      return this.apiClient.callApi(
        '/api/v1/visa/order/document', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the cancelVisaOrder operation.
     * @callback moduleapi/VisaApi~cancelVisaOrderCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ApplicationResponse{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {String} id 
     * @param {module:api/VisaApi~cancelVisaOrderCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    cancelVisaOrder(id, callback) {
      
      let postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling cancelVisaOrder");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'id': id
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerScheme'];
      let contentTypes = [];
      let accepts = ['*/*'];
      let returnType = ApplicationResponse;

      return this.apiClient.callApi(
        '/api/v1/visa/cancel', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the createOrder operation.
     * @callback moduleapi/VisaApi~createOrderCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ApplicationResponse{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {String} id 
     * @param {module:api/VisaApi~createOrderCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    createOrder(id, callback) {
      
      let postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling createOrder");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'id': id
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerScheme'];
      let contentTypes = [];
      let accepts = ['*/*'];
      let returnType = ApplicationResponse;

      return this.apiClient.callApi(
        '/api/v1/visa/order', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the createVisaDraftOrder operation.
     * @callback moduleapi/VisaApi~createVisaDraftOrderCallback
     * @param {String} error Error message, if any.
     * @param {module:model/VisaOrder{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Book Visa
     * Returns 200 if successful,visa response inside data 
     * @param {Object} opts Optional parameters
     * @param {module:model/VisaRequest} opts.body 
     * @param {module:api/VisaApi~createVisaDraftOrderCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    createVisaDraftOrder(opts, callback) {
      opts = opts || {};
      let postBody = opts['body'];

      let pathParams = {
        
      };
      let queryParams = {
        
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerScheme'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json', '*/*'];
      let returnType = VisaOrder;

      return this.apiClient.callApi(
        '/api/v1/visa/', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
    /**
     * Callback function to receive the result of the getVisaOrderStatus operation.
     * @callback moduleapi/VisaApi~getVisaOrderStatusCallback
     * @param {String} error Error message, if any.
     * @param {module:model/VisaOrder{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get visa order status
     * Returns 200 if successful
     * @param {String} bookingIdOfVisa 
     * @param {module:api/VisaApi~getVisaOrderStatusCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    getVisaOrderStatus(bookingIdOfVisa, callback) {
      
      let postBody = null;
      // verify the required parameter 'bookingIdOfVisa' is set
      if (bookingIdOfVisa === undefined || bookingIdOfVisa === null) {
        throw new Error("Missing the required parameter 'bookingIdOfVisa' when calling getVisaOrderStatus");
      }

      let pathParams = {
        
      };
      let queryParams = {
        'Booking Id of Visa': bookingIdOfVisa
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['bearerScheme'];
      let contentTypes = [];
      let accepts = ['application/json', '*/*'];
      let returnType = VisaOrder;

      return this.apiClient.callApi(
        '/api/v1/visa/status', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}