/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {Address} from './Address';
import {MemberDocument} from './MemberDocument';
import {Passport} from './Passport';

/**
 * The Member model module.
 * @module model/Member
 * @version v1.0
 */
export class Member {
  /**
   * Constructs a new <code>Member</code>.
   * @alias module:model/Member
   * @class
   * @param id {String} Id of traveller for a visa which will be returned
   * @param title {module:model/Member.TitleEnum} title of traveller
   * @param firstName {String} first name of traveller
   * @param lastName {String} last name of traveller
   * @param dateOfBirth {Date} traveller date of birth in 'yyyy-MM-dd' format
   * @param email {String} email of traveller
   * @param gender {String} 
   * @param phone {String} phone number of traveller
   * @param nationality {String} nationality of traveller
   * @param passport {module:model/Passport} 
   * @param address {module:model/Address} 
   * @param occupation {module:model/Member.OccupationEnum} occupation of traveller
   * @param isPrimary {Boolean} traveller primary
   * @param documents {Array.<module:model/MemberDocument>} list of document which is required
   */
  constructor(id, title, firstName, lastName, dateOfBirth, email, gender, phone, nationality, passport, address, occupation, isPrimary, documents) {
    this.id = id;
    this.title = title;
    this.firstName = firstName;
    this.lastName = lastName;
    this.dateOfBirth = dateOfBirth;
    this.email = email;
    this.gender = gender;
    this.phone = phone;
    this.nationality = nationality;
    this.passport = passport;
    this.address = address;
    this.occupation = occupation;
    this.isPrimary = isPrimary;
    this.documents = documents;
  }

  /**
   * Constructs a <code>Member</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Member} obj Optional instance to populate.
   * @return {module:model/Member} The populated <code>Member</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new Member();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'String');
      if (data.hasOwnProperty('title'))
        obj.title = ApiClient.convertToType(data['title'], 'String');
      if (data.hasOwnProperty('firstName'))
        obj.firstName = ApiClient.convertToType(data['firstName'], 'String');
      if (data.hasOwnProperty('middleName'))
        obj.middleName = ApiClient.convertToType(data['middleName'], 'String');
      if (data.hasOwnProperty('lastName'))
        obj.lastName = ApiClient.convertToType(data['lastName'], 'String');
      if (data.hasOwnProperty('dateOfBirth'))
        obj.dateOfBirth = ApiClient.convertToType(data['dateOfBirth'], 'Date');
      if (data.hasOwnProperty('email'))
        obj.email = ApiClient.convertToType(data['email'], 'String');
      if (data.hasOwnProperty('gender'))
        obj.gender = ApiClient.convertToType(data['gender'], 'String');
      if (data.hasOwnProperty('phone'))
        obj.phone = ApiClient.convertToType(data['phone'], 'String');
      if (data.hasOwnProperty('nationality'))
        obj.nationality = ApiClient.convertToType(data['nationality'], 'String');
      if (data.hasOwnProperty('passport'))
        obj.passport = Passport.constructFromObject(data['passport']);
      if (data.hasOwnProperty('address'))
        obj.address = Address.constructFromObject(data['address']);
      if (data.hasOwnProperty('occupation'))
        obj.occupation = ApiClient.convertToType(data['occupation'], 'String');
      if (data.hasOwnProperty('isPrimary'))
        obj.isPrimary = ApiClient.convertToType(data['isPrimary'], 'Boolean');
      if (data.hasOwnProperty('supplierId'))
        obj.supplierId = ApiClient.convertToType(data['supplierId'], 'String');
      if (data.hasOwnProperty('documents'))
        obj.documents = ApiClient.convertToType(data['documents'], [MemberDocument]);
    }
    return obj;
  }
}

/**
 * Id of traveller for a visa which will be returned
 * @member {String} id
 */
Member.prototype.id = undefined;

/**
 * Allowed values for the <code>title</code> property.
 * @enum {String}
 * @readonly
 */
Member.TitleEnum = {
  /**
   * value: "Mr"
   * @const
   */
  mr: "Mr",

  /**
   * value: "Ms"
   * @const
   */
  ms: "Ms",

  /**
   * value: "Mrs"
   * @const
   */
  mrs: "Mrs",

  /**
   * value: "Miss"
   * @const
   */
  miss: "Miss",

  /**
   * value: "Master"
   * @const
   */
  master: "Master"
};
/**
 * title of traveller
 * @member {module:model/Member.TitleEnum} title
 */
Member.prototype.title = undefined;

/**
 * first name of traveller
 * @member {String} firstName
 */
Member.prototype.firstName = undefined;

/**
 * middle name of traveller
 * @member {String} middleName
 */
Member.prototype.middleName = undefined;

/**
 * last name of traveller
 * @member {String} lastName
 */
Member.prototype.lastName = undefined;

/**
 * traveller date of birth in 'yyyy-MM-dd' format
 * @member {Date} dateOfBirth
 */
Member.prototype.dateOfBirth = undefined;

/**
 * email of traveller
 * @member {String} email
 */
Member.prototype.email = undefined;

/**
 * @member {String} gender
 */
Member.prototype.gender = undefined;

/**
 * phone number of traveller
 * @member {String} phone
 */
Member.prototype.phone = undefined;

/**
 * nationality of traveller
 * @member {String} nationality
 */
Member.prototype.nationality = undefined;

/**
 * @member {module:model/Passport} passport
 */
Member.prototype.passport = undefined;

/**
 * @member {module:model/Address} address
 */
Member.prototype.address = undefined;

/**
 * Allowed values for the <code>occupation</code> property.
 * @enum {String}
 * @readonly
 */
Member.OccupationEnum = {
  /**
   * value: "SELF_EMPLOYED"
   * @const
   */
  SELF_EMPLOYED: "SELF_EMPLOYED",

  /**
   * value: "SALARIED"
   * @const
   */
  SALARIED: "SALARIED",

  /**
   * value: "STUDENT"
   * @const
   */
  STUDENT: "STUDENT",

  /**
   * value: "OTHER"
   * @const
   */
  OTHER: "OTHER"
};
/**
 * occupation of traveller
 * @member {module:model/Member.OccupationEnum} occupation
 */
Member.prototype.occupation = undefined;

/**
 * traveller primary
 * @member {Boolean} isPrimary
 */
Member.prototype.isPrimary = undefined;

/**
 * supplier Id generated by us
 * @member {String} supplierId
 */
Member.prototype.supplierId = undefined;

/**
 * list of document which is required
 * @member {Array.<module:model/MemberDocument>} documents
 */
Member.prototype.documents = undefined;

