/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {ActionLog} from './ActionLog';
import {Address} from './Address';
import {MemberDocument} from './MemberDocument';
import {Passport} from './Passport';
import {Tax} from './Tax';

/**
 * The MemberDAO model module.
 * @module model/MemberDAO
 * @version v1.0
 */
export class MemberDAO {
  /**
   * Constructs a new <code>MemberDAO</code>.
   * @alias module:model/MemberDAO
   * @class
   * @param logs {Array.<module:model/ActionLog>} 
   */
  constructor(logs) {
    this.logs = logs;
  }

  /**
   * Constructs a <code>MemberDAO</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/MemberDAO} obj Optional instance to populate.
   * @return {module:model/MemberDAO} The populated <code>MemberDAO</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new MemberDAO();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'String');
      if (data.hasOwnProperty('supplierMemberId'))
        obj.supplierMemberId = ApiClient.convertToType(data['supplierMemberId'], 'String');
      if (data.hasOwnProperty('ancillaryType'))
        obj.ancillaryType = ApiClient.convertToType(data['ancillaryType'], 'String');
      if (data.hasOwnProperty('linkedSupplierBookingId'))
        obj.linkedSupplierBookingId = ApiClient.convertToType(data['linkedSupplierBookingId'], 'String');
      if (data.hasOwnProperty('title'))
        obj.title = ApiClient.convertToType(data['title'], 'String');
      if (data.hasOwnProperty('firstName'))
        obj.firstName = ApiClient.convertToType(data['firstName'], 'String');
      if (data.hasOwnProperty('middleName'))
        obj.middleName = ApiClient.convertToType(data['middleName'], 'String');
      if (data.hasOwnProperty('lastName'))
        obj.lastName = ApiClient.convertToType(data['lastName'], 'String');
      if (data.hasOwnProperty('dateOfBirth'))
        obj.dateOfBirth = ApiClient.convertToType(data['dateOfBirth'], 'Date');
      if (data.hasOwnProperty('email'))
        obj.email = ApiClient.convertToType(data['email'], 'String');
      if (data.hasOwnProperty('age'))
        obj.age = ApiClient.convertToType(data['age'], 'Number');
      if (data.hasOwnProperty('gender'))
        obj.gender = ApiClient.convertToType(data['gender'], 'String');
      if (data.hasOwnProperty('phone'))
        obj.phone = ApiClient.convertToType(data['phone'], 'String');
      if (data.hasOwnProperty('nationality'))
        obj.nationality = ApiClient.convertToType(data['nationality'], 'String');
      if (data.hasOwnProperty('passport'))
        obj.passport = Passport.constructFromObject(data['passport']);
      if (data.hasOwnProperty('taxInfo'))
        obj.taxInfo = Tax.constructFromObject(data['taxInfo']);
      if (data.hasOwnProperty('address'))
        obj.address = Address.constructFromObject(data['address']);
      if (data.hasOwnProperty('occupation'))
        obj.occupation = ApiClient.convertToType(data['occupation'], 'String');
      if (data.hasOwnProperty('isPrimary'))
        obj.isPrimary = ApiClient.convertToType(data['isPrimary'], 'Boolean');
      if (data.hasOwnProperty('documents'))
        obj.documents = ApiClient.convertToType(data['documents'], [MemberDocument]);
      if (data.hasOwnProperty('status'))
        obj.status = ApiClient.convertToType(data['status'], 'String');
      if (data.hasOwnProperty('logs'))
        obj.logs = ApiClient.convertToType(data['logs'], [ActionLog]);
    }
    return obj;
  }
}

/**
 * @member {String} id
 */
MemberDAO.prototype.id = undefined;

/**
 * @member {String} supplierMemberId
 */
MemberDAO.prototype.supplierMemberId = undefined;

/**
 * Allowed values for the <code>ancillaryType</code> property.
 * @enum {String}
 * @readonly
 */
MemberDAO.AncillaryTypeEnum = {
  /**
   * value: "INSURANCE"
   * @const
   */
  INSURANCE: "INSURANCE",

  /**
   * value: "CAB"
   * @const
   */
  CAB: "CAB",

  /**
   * value: "VISA"
   * @const
   */
  VISA: "VISA",

  /**
   * value: "GROUND"
   * @const
   */
  GROUND: "GROUND",

  /**
   * value: "EVISA"
   * @const
   */
  EVISA: "EVISA",

  /**
   * value: "DATA"
   * @const
   */
  DATA: "DATA"
};
/**
 * @member {module:model/MemberDAO.AncillaryTypeEnum} ancillaryType
 */
MemberDAO.prototype.ancillaryType = undefined;

/**
 * @member {String} linkedSupplierBookingId
 */
MemberDAO.prototype.linkedSupplierBookingId = undefined;

/**
 * @member {String} title
 */
MemberDAO.prototype.title = undefined;

/**
 * @member {String} firstName
 */
MemberDAO.prototype.firstName = undefined;

/**
 * @member {String} middleName
 */
MemberDAO.prototype.middleName = undefined;

/**
 * @member {String} lastName
 */
MemberDAO.prototype.lastName = undefined;

/**
 * @member {Date} dateOfBirth
 */
MemberDAO.prototype.dateOfBirth = undefined;

/**
 * @member {String} email
 */
MemberDAO.prototype.email = undefined;

/**
 * @member {Number} age
 */
MemberDAO.prototype.age = undefined;

/**
 * @member {String} gender
 */
MemberDAO.prototype.gender = undefined;

/**
 * @member {String} phone
 */
MemberDAO.prototype.phone = undefined;

/**
 * @member {String} nationality
 */
MemberDAO.prototype.nationality = undefined;

/**
 * @member {module:model/Passport} passport
 */
MemberDAO.prototype.passport = undefined;

/**
 * @member {module:model/Tax} taxInfo
 */
MemberDAO.prototype.taxInfo = undefined;

/**
 * @member {module:model/Address} address
 */
MemberDAO.prototype.address = undefined;

/**
 * @member {String} occupation
 */
MemberDAO.prototype.occupation = undefined;

/**
 * @member {Boolean} isPrimary
 */
MemberDAO.prototype.isPrimary = undefined;

/**
 * @member {Array.<module:model/MemberDocument>} documents
 */
MemberDAO.prototype.documents = undefined;

/**
 * Allowed values for the <code>status</code> property.
 * @enum {String}
 * @readonly
 */
MemberDAO.StatusEnum = {
  /**
   * value: "ORDER_SUBMIT"
   * @const
   */
  ORDER_SUBMIT: "ORDER_SUBMIT",

  /**
   * value: "IN_PROGRESS"
   * @const
   */
  IN_PROGRESS: "IN_PROGRESS",

  /**
   * value: "ORDER_DRAFT"
   * @const
   */
  ORDER_DRAFT: "ORDER_DRAFT",

  /**
   * value: "ORDER_INITIATED"
   * @const
   */
  ORDER_INITIATED: "ORDER_INITIATED",

  /**
   * value: "COMPLETED"
   * @const
   */
  COMPLETED: "COMPLETED",

  /**
   * value: "CANCELLED"
   * @const
   */
  CANCELLED: "CANCELLED",

  /**
   * value: "DOCUMENT_PENDING"
   * @const
   */
  DOCUMENT_PENDING: "DOCUMENT_PENDING",

  /**
   * value: "DOCUMENT_COMPLETED"
   * @const
   */
  DOCUMENT_COMPLETED: "DOCUMENT_COMPLETED",

  /**
   * value: "PARTIAL_APPROVED"
   * @const
   */
  PARTIAL_APPROVED: "PARTIAL_APPROVED",

  /**
   * value: "APPROVED"
   * @const
   */
  APPROVED: "APPROVED",

  /**
   * value: "DISPATCHED"
   * @const
   */
  DISPATCHED: "DISPATCHED",

  /**
   * value: "COUNTRY_SELECTED"
   * @const
   */
  COUNTRY_SELECTED: "COUNTRY_SELECTED",

  /**
   * value: "QUOTE_SELECTED"
   * @const
   */
  QUOTE_SELECTED: "QUOTE_SELECTED",

  /**
   * value: "VISA_APPLICATION_APPROVED"
   * @const
   */
  VISA_APPLICATION_APPROVED: "VISA_APPLICATION_APPROVED",

  /**
   * value: "PARTIAL_APPLICATIONS_APPROVED"
   * @const
   */
  PARTIAL_APPLICATIONS_APPROVED: "PARTIAL_APPLICATIONS_APPROVED",

  /**
   * value: "VISA_APPLIED_IN_EMBASSY"
   * @const
   */
  VISA_APPLIED_IN_EMBASSY: "VISA_APPLIED_IN_EMBASSY",

  /**
   * value: "VISA_APPLICATION_REJECTED"
   * @const
   */
  VISA_APPLICATION_REJECTED: "VISA_APPLICATION_REJECTED",

  /**
   * value: "PAYMENT_INITIATED"
   * @const
   */
  PAYMENT_INITIATED: "PAYMENT_INITIATED",

  /**
   * value: "PAYMENT_FAILED"
   * @const
   */
  PAYMENT_FAILED: "PAYMENT_FAILED",

  /**
   * value: "PAYMENT_COMPLETED"
   * @const
   */
  PAYMENT_COMPLETED: "PAYMENT_COMPLETED",

  /**
   * value: "DOCUMENT_COLLECTED"
   * @const
   */
  DOCUMENT_COLLECTED: "DOCUMENT_COLLECTED",

  /**
   * value: "BOOKING_CANCELLED"
   * @const
   */
  BOOKING_CANCELLED: "BOOKING_CANCELLED",

  /**
   * value: "EXTRA_DOCUMENT_REQUIRED"
   * @const
   */
  EXTRA_DOCUMENT_REQUIRED: "EXTRA_DOCUMENT_REQUIRED",

  /**
   * value: "DOCUMENT_COLLECTION_RESCHEDULING"
   * @const
   */
  DOCUMENT_COLLECTION_RESCHEDULING: "DOCUMENT_COLLECTION_RESCHEDULING",

  /**
   * value: "DOCUMENT_RETURN_RESCHEDULING"
   * @const
   */
  DOCUMENT_RETURN_RESCHEDULING: "DOCUMENT_RETURN_RESCHEDULING",

  /**
   * value: "USER_NOT_RESPONDING"
   * @const
   */
  USER_NOT_RESPONDING: "USER_NOT_RESPONDING",

  /**
   * value: "DOCUMENT_UPLOAD_PENDING"
   * @const
   */
  DOCUMENT_UPLOAD_PENDING: "DOCUMENT_UPLOAD_PENDING",

  /**
   * value: "DOCUMENT_TO_BE_UPLOADED_LATER"
   * @const
   */
  DOCUMENT_TO_BE_UPLOADED_LATER: "DOCUMENT_TO_BE_UPLOADED_LATER",

  /**
   * value: "DOCUMENT_UPLOADED"
   * @const
   */
  DOCUMENT_UPLOADED: "DOCUMENT_UPLOADED",

  /**
   * value: "REJECTED"
   * @const
   */
  REJECTED: "REJECTED",

  /**
   * value: "ADDRESS_TO_BE_COLLECTED"
   * @const
   */
  ADDRESS_TO_BE_COLLECTED: "ADDRESS_TO_BE_COLLECTED",

  /**
   * value: "ADDRESS_COLLECTED"
   * @const
   */
  ADDRESS_COLLECTED: "ADDRESS_COLLECTED"
};
/**
 * @member {module:model/MemberDAO.StatusEnum} status
 */
MemberDAO.prototype.status = undefined;

/**
 * @member {Array.<module:model/ActionLog>} logs
 */
MemberDAO.prototype.logs = undefined;

