/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';

/**
 * The OriginDestinationCode model module.
 * @module model/OriginDestinationCode
 * @version v1.0
 */
export class OriginDestinationCode {
  /**
   * Constructs a new <code>OriginDestinationCode</code>.
   * trip destination details
   * @alias module:model/OriginDestinationCode
   * @class
   * @param countryCode {String} origin or destination country alpha-2 code has to be passed here
   */
  constructor(countryCode) {
    this.countryCode = countryCode;
  }

  /**
   * Constructs a <code>OriginDestinationCode</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/OriginDestinationCode} obj Optional instance to populate.
   * @return {module:model/OriginDestinationCode} The populated <code>OriginDestinationCode</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new OriginDestinationCode();
      if (data.hasOwnProperty('iata'))
        obj.iata = ApiClient.convertToType(data['iata'], 'String');
      if (data.hasOwnProperty('city'))
        obj.city = ApiClient.convertToType(data['city'], 'String');
      if (data.hasOwnProperty('country'))
        obj.country = ApiClient.convertToType(data['country'], 'String');
      if (data.hasOwnProperty('countryCode'))
        obj.countryCode = ApiClient.convertToType(data['countryCode'], 'String');
    }
    return obj;
  }
}

/**
 * origin or destination IATA airport code must passed here
 * @member {String} iata
 */
OriginDestinationCode.prototype.iata = undefined;

/**
 * IATA airport code must passed here
 * @member {String} city
 */
OriginDestinationCode.prototype.city = undefined;

/**
 * @member {String} country
 */
OriginDestinationCode.prototype.country = undefined;

/**
 * origin or destination country alpha-2 code has to be passed here
 * @member {String} countryCode
 */
OriginDestinationCode.prototype.countryCode = undefined;

