/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';

/**
 * The Passport model module.
 * @module model/Passport
 * @version v1.0
 */
export class Passport {
  /**
   * Constructs a new <code>Passport</code>.
   * @alias module:model/Passport
   * @class
   * @param issuingCountry {String} passport issued country alpha-2 code has to be passed here
   * @param _number {String} passport number details
   * @param expiration {Date} passport expiration date in 'yyyy-MM-dd' format
   */
  constructor(issuingCountry, _number, expiration) {
    this.issuingCountry = issuingCountry;
    this._number = _number;
    this.expiration = expiration;
  }

  /**
   * Constructs a <code>Passport</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Passport} obj Optional instance to populate.
   * @return {module:model/Passport} The populated <code>Passport</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new Passport();
      if (data.hasOwnProperty('issuingCountry'))
        obj.issuingCountry = ApiClient.convertToType(data['issuingCountry'], 'String');
      if (data.hasOwnProperty('number'))
        obj._number = ApiClient.convertToType(data['number'], 'String');
      if (data.hasOwnProperty('expiration'))
        obj.expiration = ApiClient.convertToType(data['expiration'], 'Date');
    }
    return obj;
  }
}

/**
 * passport issued country alpha-2 code has to be passed here
 * @member {String} issuingCountry
 */
Passport.prototype.issuingCountry = undefined;

/**
 * passport number details
 * @member {String} _number
 */
Passport.prototype._number = undefined;

/**
 * passport expiration date in 'yyyy-MM-dd' format
 * @member {Date} expiration
 */
Passport.prototype.expiration = undefined;

