/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {OriginDestination} from './OriginDestination';
import {ProductMeta} from './ProductMeta';
import {VisaProduct} from './VisaProduct';

/**
 * The Product model module.
 * @module model/Product
 * @version v1.0
 */
export class Product {
  /**
   * Constructs a new <code>Product</code>.
   * @alias module:model/Product
   * @class
   */
  constructor() {
  }

  /**
   * Constructs a <code>Product</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Product} obj Optional instance to populate.
   * @return {module:model/Product} The populated <code>Product</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new Product();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'String');
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('ancillaryType'))
        obj.ancillaryType = ApiClient.convertToType(data['ancillaryType'], 'String');
      if (data.hasOwnProperty('origin'))
        obj.origin = ApiClient.convertToType(data['origin'], [OriginDestination]);
      if (data.hasOwnProperty('destination'))
        obj.destination = ApiClient.convertToType(data['destination'], [OriginDestination]);
      if (data.hasOwnProperty('additionalInfo'))
        obj.additionalInfo = ProductMeta.constructFromObject(data['additionalInfo']);
      if (data.hasOwnProperty('productInformation'))
        obj.productInformation = VisaProduct.constructFromObject(data['productInformation']);
    }
    return obj;
  }
}

/**
 * @member {String} id
 */
Product.prototype.id = undefined;

/**
 * Name of the Product
 * @member {String} name
 */
Product.prototype.name = undefined;

/**
 * Allowed values for the <code>ancillaryType</code> property.
 * @enum {String}
 * @readonly
 */
Product.AncillaryTypeEnum = {
  /**
   * value: "INSURANCE"
   * @const
   */
  INSURANCE: "INSURANCE",

  /**
   * value: "CAB"
   * @const
   */
  CAB: "CAB",

  /**
   * value: "VISA"
   * @const
   */
  VISA: "VISA",

  /**
   * value: "GROUND"
   * @const
   */
  GROUND: "GROUND",

  /**
   * value: "EVISA"
   * @const
   */
  EVISA: "EVISA",

  /**
   * value: "DATA"
   * @const
   */
  DATA: "DATA"
};
/**
 * type of the Product
 * @member {module:model/Product.AncillaryTypeEnum} ancillaryType
 */
Product.prototype.ancillaryType = undefined;

/**
 * trip origin
 * @member {Array.<module:model/OriginDestination>} origin
 */
Product.prototype.origin = undefined;

/**
 * trip destination
 * @member {Array.<module:model/OriginDestination>} destination
 */
Product.prototype.destination = undefined;

/**
 * @member {module:model/ProductMeta} additionalInfo
 */
Product.prototype.additionalInfo = undefined;

/**
 * @member {module:model/VisaProduct} productInformation
 */
Product.prototype.productInformation = undefined;

