/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {DateTimeAndTimeZone} from './DateTimeAndTimeZone';
import {OriginDestinationCode} from './OriginDestinationCode';

/**
 * The Trip model module.
 * @module model/Trip
 * @version v1.0
 */
export class Trip {
  /**
   * Constructs a new <code>Trip</code>.
   * @alias module:model/Trip
   * @class
   * @param tripType {module:model/Trip.TripTypeEnum} Type of trip
   * @param visaType {module:model/Trip.VisaTypeEnum} VisaType/purpose of trip
   * @param departureAt {module:model/DateTimeAndTimeZone} 
   * @param arrivalAt {module:model/DateTimeAndTimeZone} 
   * @param origin {module:model/OriginDestinationCode} 
   * @param destination {Array.<module:model/OriginDestinationCode>} trip destination details
   */
  constructor(tripType, visaType, departureAt, arrivalAt, origin, destination) {
    this.tripType = tripType;
    this.visaType = visaType;
    this.departureAt = departureAt;
    this.arrivalAt = arrivalAt;
    this.origin = origin;
    this.destination = destination;
  }

  /**
   * Constructs a <code>Trip</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Trip} obj Optional instance to populate.
   * @return {module:model/Trip} The populated <code>Trip</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new Trip();
      if (data.hasOwnProperty('tripType'))
        obj.tripType = ApiClient.convertToType(data['tripType'], 'String');
      if (data.hasOwnProperty('visaType'))
        obj.visaType = ApiClient.convertToType(data['visaType'], 'String');
      if (data.hasOwnProperty('departureAt'))
        obj.departureAt = DateTimeAndTimeZone.constructFromObject(data['departureAt']);
      if (data.hasOwnProperty('arrivalAt'))
        obj.arrivalAt = DateTimeAndTimeZone.constructFromObject(data['arrivalAt']);
      if (data.hasOwnProperty('origin'))
        obj.origin = OriginDestinationCode.constructFromObject(data['origin']);
      if (data.hasOwnProperty('destination'))
        obj.destination = ApiClient.convertToType(data['destination'], [OriginDestinationCode]);
      if (data.hasOwnProperty('isDomestic'))
        obj.isDomestic = ApiClient.convertToType(data['isDomestic'], 'Boolean');
    }
    return obj;
  }
}

/**
 * Allowed values for the <code>tripType</code> property.
 * @enum {String}
 * @readonly
 */
Trip.TripTypeEnum = {
  /**
   * value: "SINGLE"
   * @const
   */
  SINGLE: "SINGLE",

  /**
   * value: "ANNUAL"
   * @const
   */
  ANNUAL: "ANNUAL",

  /**
   * value: "ROUND"
   * @const
   */
  ROUND: "ROUND",

  /**
   * value: "MULTI"
   * @const
   */
  MULTI: "MULTI"
};
/**
 * Type of trip
 * @member {module:model/Trip.TripTypeEnum} tripType
 */
Trip.prototype.tripType = undefined;

/**
 * Allowed values for the <code>visaType</code> property.
 * @enum {String}
 * @readonly
 */
Trip.VisaTypeEnum = {
  /**
   * value: "TOURIST"
   * @const
   */
  TOURIST: "TOURIST",

  /**
   * value: "BUSINESS"
   * @const
   */
  BUSINESS: "BUSINESS",

  /**
   * value: "TRANSIT"
   * @const
   */
  TRANSIT: "TRANSIT",

  /**
   * value: "STUDENT"
   * @const
   */
  STUDENT: "STUDENT"
};
/**
 * VisaType/purpose of trip
 * @member {module:model/Trip.VisaTypeEnum} visaType
 */
Trip.prototype.visaType = undefined;

/**
 * @member {module:model/DateTimeAndTimeZone} departureAt
 */
Trip.prototype.departureAt = undefined;

/**
 * @member {module:model/DateTimeAndTimeZone} arrivalAt
 */
Trip.prototype.arrivalAt = undefined;

/**
 * @member {module:model/OriginDestinationCode} origin
 */
Trip.prototype.origin = undefined;

/**
 * trip destination details
 * @member {Array.<module:model/OriginDestinationCode>} destination
 */
Trip.prototype.destination = undefined;

/**
 * @member {Boolean} isDomestic
 * @default false
 */
Trip.prototype.isDomestic = false;

