/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {DateTimeAndTimeZone} from './DateTimeAndTimeZone';
import {OriginDestinationCode} from './OriginDestinationCode';

/**
 * The TripDAO model module.
 * @module model/TripDAO
 * @version v1.0
 */
export class TripDAO {
  /**
   * Constructs a new <code>TripDAO</code>.
   * @alias module:model/TripDAO
   * @class
   */
  constructor() {
  }

  /**
   * Constructs a <code>TripDAO</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TripDAO} obj Optional instance to populate.
   * @return {module:model/TripDAO} The populated <code>TripDAO</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new TripDAO();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'String');
      if (data.hasOwnProperty('tripType'))
        obj.tripType = ApiClient.convertToType(data['tripType'], 'String');
      if (data.hasOwnProperty('visaType'))
        obj.visaType = ApiClient.convertToType(data['visaType'], 'String');
      if (data.hasOwnProperty('departureAt'))
        obj.departureAt = DateTimeAndTimeZone.constructFromObject(data['departureAt']);
      if (data.hasOwnProperty('arrivalAt'))
        obj.arrivalAt = DateTimeAndTimeZone.constructFromObject(data['arrivalAt']);
      if (data.hasOwnProperty('origin'))
        obj.origin = OriginDestinationCode.constructFromObject(data['origin']);
      if (data.hasOwnProperty('destination'))
        obj.destination = ApiClient.convertToType(data['destination'], [OriginDestinationCode]);
      if (data.hasOwnProperty('isDomestic'))
        obj.isDomestic = ApiClient.convertToType(data['isDomestic'], 'Boolean');
      if (data.hasOwnProperty('trip'))
        obj.trip = TripDAO.constructFromObject(data['trip']);
    }
    return obj;
  }
}

/**
 * @member {String} id
 */
TripDAO.prototype.id = undefined;

/**
 * Allowed values for the <code>tripType</code> property.
 * @enum {String}
 * @readonly
 */
TripDAO.TripTypeEnum = {
  /**
   * value: "SINGLE"
   * @const
   */
  SINGLE: "SINGLE",

  /**
   * value: "MULTI"
   * @const
   */
  MULTI: "MULTI"
};
/**
 * Type of trip
 * @member {module:model/TripDAO.TripTypeEnum} tripType
 */
TripDAO.prototype.tripType = undefined;

/**
 * visa type/purpose of trip
 * @member {String} visaType
 */
TripDAO.prototype.visaType = undefined;

/**
 * @member {module:model/DateTimeAndTimeZone} departureAt
 */
TripDAO.prototype.departureAt = undefined;

/**
 * @member {module:model/DateTimeAndTimeZone} arrivalAt
 */
TripDAO.prototype.arrivalAt = undefined;

/**
 * @member {module:model/OriginDestinationCode} origin
 */
TripDAO.prototype.origin = undefined;

/**
 * trip destination details
 * @member {Array.<module:model/OriginDestinationCode>} destination
 */
TripDAO.prototype.destination = undefined;

/**
 * @member {Boolean} isDomestic
 * @default false
 */
TripDAO.prototype.isDomestic = false;

/**
 * @member {module:model/TripDAO} trip
 */
TripDAO.prototype.trip = undefined;

