/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {MemberDAO} from './MemberDAO';
import {Product} from './Product';
import {TripDAO} from './TripDAO';

/**
 * The VisaOrder model module.
 * @module model/VisaOrder
 * @version v1.0
 */
export class VisaOrder {
  /**
   * Constructs a new <code>VisaOrder</code>.
   * @alias module:model/VisaOrder
   * @class
   */
  constructor() {
  }

  /**
   * Constructs a <code>VisaOrder</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/VisaOrder} obj Optional instance to populate.
   * @return {module:model/VisaOrder} The populated <code>VisaOrder</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new VisaOrder();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'String');
      if (data.hasOwnProperty('linkedTrip'))
        obj.linkedTrip = ApiClient.convertToType(data['linkedTrip'], 'String');
      if (data.hasOwnProperty('bookingStatus'))
        obj.bookingStatus = ApiClient.convertToType(data['bookingStatus'], 'String');
      if (data.hasOwnProperty('linkedProduct'))
        obj.linkedProduct = ApiClient.convertToType(data['linkedProduct'], 'String');
      if (data.hasOwnProperty('linkedMembers'))
        obj.linkedMembers = ApiClient.convertToType(data['linkedMembers'], ['String']);
      if (data.hasOwnProperty('dateOfTravel'))
        obj.dateOfTravel = ApiClient.convertToType(data['dateOfTravel'], 'Date');
      if (data.hasOwnProperty('totalAmount'))
        obj.totalAmount = ApiClient.convertToType(data['totalAmount'], 'Number');
      if (data.hasOwnProperty('bookingAmount'))
        obj.bookingAmount = ApiClient.convertToType(data['bookingAmount'], 'Number');
      if (data.hasOwnProperty('totalMarkup'))
        obj.totalMarkup = ApiClient.convertToType(data['totalMarkup'], 'Number');
      if (data.hasOwnProperty('trip'))
        obj.trip = TripDAO.constructFromObject(data['trip']);
      if (data.hasOwnProperty('members'))
        obj.members = ApiClient.convertToType(data['members'], [MemberDAO]);
      if (data.hasOwnProperty('visaDownloadLink'))
        obj.visaDownloadLink = ApiClient.convertToType(data['visaDownloadLink'], 'String');
      if (data.hasOwnProperty('product'))
        obj.product = Product.constructFromObject(data['product']);
    }
    return obj;
  }
}

/**
 * @member {String} id
 */
VisaOrder.prototype.id = undefined;

/**
 * @member {String} linkedTrip
 */
VisaOrder.prototype.linkedTrip = undefined;

/**
 * Allowed values for the <code>bookingStatus</code> property.
 * @enum {String}
 * @readonly
 */
VisaOrder.BookingStatusEnum = {
  /**
   * value: "IN_PROGRESS"
   * @const
   */
  IN_PROGRESS: "IN_PROGRESS",

  /**
   * value: "ORDER_INITIATED"
   * @const
   */
  ORDER_INITIATED: "ORDER_INITIATED",

  /**
   * value: "COMPLETED"
   * @const
   */
  COMPLETED: "COMPLETED",

  /**
   * value: "CANCELLED"
   * @const
   */
  CANCELLED: "CANCELLED",

  /**
   * value: "DOCUMENT_PENDING"
   * @const
   */
  DOCUMENT_PENDING: "DOCUMENT_PENDING",

  /**
   * value: "DOCUMENT_COMPLETED"
   * @const
   */
  DOCUMENT_COMPLETED: "DOCUMENT_COMPLETED",

  /**
   * value: "PARTIAL_APPROVED"
   * @const
   */
  PARTIAL_APPROVED: "PARTIAL_APPROVED",

  /**
   * value: "APPROVED"
   * @const
   */
  APPROVED: "APPROVED",

  /**
   * value: "DISPATCHED"
   * @const
   */
  DISPATCHED: "DISPATCHED"
};
/**
 * Status of visa order
 * @member {module:model/VisaOrder.BookingStatusEnum} bookingStatus
 */
VisaOrder.prototype.bookingStatus = undefined;

/**
 * Product code which visa was booked for
 * @member {String} linkedProduct
 */
VisaOrder.prototype.linkedProduct = undefined;

/**
 * Members who are liked with visa order
 * @member {Array.<String>} linkedMembers
 */
VisaOrder.prototype.linkedMembers = undefined;

/**
 * Date of travel
 * @member {Date} dateOfTravel
 */
VisaOrder.prototype.dateOfTravel = undefined;

/**
 * Total Booking Amount
 * @member {Number} totalAmount
 */
VisaOrder.prototype.totalAmount = undefined;

/**
 * Booking Amount
 * @member {Number} bookingAmount
 */
VisaOrder.prototype.bookingAmount = undefined;

/**
 * Mark up Charges for booking
 * @member {Number} totalMarkup
 */
VisaOrder.prototype.totalMarkup = undefined;

/**
 * @member {module:model/TripDAO} trip
 */
VisaOrder.prototype.trip = undefined;

/**
 * @member {Array.<module:model/MemberDAO>} members
 */
VisaOrder.prototype.members = undefined;

/**
 * @member {String} visaDownloadLink
 */
VisaOrder.prototype.visaDownloadLink = undefined;

/**
 * @member {module:model/Product} product
 */
VisaOrder.prototype.product = undefined;

