/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {RequiredDocument} from './RequiredDocument';

/**
 * The VisaProduct model module.
 * @module model/VisaProduct
 * @version v1.0
 */
export class VisaProduct {
  /**
   * Constructs a new <code>VisaProduct</code>.
   * Product information
   * @alias module:model/VisaProduct
   * @class
   */
  constructor() {
  }

  /**
   * Constructs a <code>VisaProduct</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/VisaProduct} obj Optional instance to populate.
   * @return {module:model/VisaProduct} The populated <code>VisaProduct</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new VisaProduct();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'String');
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('supplierId'))
        obj.supplierId = ApiClient.convertToType(data['supplierId'], 'String');
      if (data.hasOwnProperty('country'))
        obj.country = ApiClient.convertToType(data['country'], 'String');
      if (data.hasOwnProperty('visaType'))
        obj.visaType = ApiClient.convertToType(data['visaType'], 'String');
      if (data.hasOwnProperty('tripType'))
        obj.tripType = ApiClient.convertToType(data['tripType'], 'String');
      if (data.hasOwnProperty('stayPeriod'))
        obj.stayPeriod = ApiClient.convertToType(data['stayPeriod'], 'String');
      if (data.hasOwnProperty('currency'))
        obj.currency = ApiClient.convertToType(data['currency'], 'String');
      if (data.hasOwnProperty('unitPrice'))
        obj.unitPrice = ApiClient.convertToType(data['unitPrice'], 'String');
      if (data.hasOwnProperty('tax'))
        obj.tax = ApiClient.convertToType(data['tax'], 'String');
      if (data.hasOwnProperty('validity'))
        obj.validity = ApiClient.convertToType(data['validity'], 'String');
      if (data.hasOwnProperty('processingTime'))
        obj.processingTime = ApiClient.convertToType(data['processingTime'], 'String');
      if (data.hasOwnProperty('minProcessingTime'))
        obj.minProcessingTime = ApiClient.convertToType(data['minProcessingTime'], 'Number');
      if (data.hasOwnProperty('maxProcessingTime'))
        obj.maxProcessingTime = ApiClient.convertToType(data['maxProcessingTime'], 'Number');
      if (data.hasOwnProperty('minProcessingTimeMatrix'))
        obj.minProcessingTimeMatrix = ApiClient.convertToType(data['minProcessingTimeMatrix'], 'String');
      if (data.hasOwnProperty('maxProcessingTimeMatrix'))
        obj.maxProcessingTimeMatrix = ApiClient.convertToType(data['maxProcessingTimeMatrix'], 'String');
      if (data.hasOwnProperty('visaCategory'))
        obj.visaCategory = ApiClient.convertToType(data['visaCategory'], 'String');
      if (data.hasOwnProperty('disclaimer'))
        obj.disclaimer = ApiClient.convertToType(data['disclaimer'], 'String');
      if (data.hasOwnProperty('processingType'))
        obj.processingType = ApiClient.convertToType(data['processingType'], 'String');
      if (data.hasOwnProperty('minTravelDate'))
        obj.minTravelDate = ApiClient.convertToType(data['minTravelDate'], 'String');
      if (data.hasOwnProperty('withServices'))
        obj.withServices = ApiClient.convertToType(data['withServices'], 'String');
      if (data.hasOwnProperty('requiredDocuments'))
        obj.requiredDocuments = ApiClient.convertToType(data['requiredDocuments'], [RequiredDocument]);
    }
    return obj;
  }
}

/**
 * Visa product id
 * @member {String} id
 */
VisaProduct.prototype.id = undefined;

/**
 * Visa product name
 * @member {String} name
 */
VisaProduct.prototype.name = undefined;

/**
 * Visa product supplier reference Id
 * @member {String} supplierId
 */
VisaProduct.prototype.supplierId = undefined;

/**
 * Visa booking country
 * @member {String} country
 */
VisaProduct.prototype.country = undefined;

/**
 * Trip visa type
 * @member {String} visaType
 */
VisaProduct.prototype.visaType = undefined;

/**
 * Trip Type
 * @member {String} tripType
 */
VisaProduct.prototype.tripType = undefined;

/**
 * Trip stay period
 * @member {String} stayPeriod
 */
VisaProduct.prototype.stayPeriod = undefined;

/**
 * @member {String} currency
 */
VisaProduct.prototype.currency = undefined;

/**
 * Price per unit
 * @member {String} unitPrice
 */
VisaProduct.prototype.unitPrice = undefined;

/**
 * Tax inclusion
 * @member {String} tax
 */
VisaProduct.prototype.tax = undefined;

/**
 * Trip Validaity
 * @member {String} validity
 */
VisaProduct.prototype.validity = undefined;

/**
 * @member {String} processingTime
 */
VisaProduct.prototype.processingTime = undefined;

/**
 * Time required minimum processing time get visa
 * @member {Number} minProcessingTime
 */
VisaProduct.prototype.minProcessingTime = undefined;

/**
 * Time required maximum processing time get visa
 * @member {Number} maxProcessingTime
 */
VisaProduct.prototype.maxProcessingTime = undefined;

/**
 * Time unit for minimum processing time get visa
 * @member {String} minProcessingTimeMatrix
 */
VisaProduct.prototype.minProcessingTimeMatrix = undefined;

/**
 * Time unit for maximum processing time get visa
 * @member {String} maxProcessingTimeMatrix
 */
VisaProduct.prototype.maxProcessingTimeMatrix = undefined;

/**
 * @member {String} visaCategory
 */
VisaProduct.prototype.visaCategory = undefined;

/**
 * Terms and condition
 * @member {String} disclaimer
 */
VisaProduct.prototype.disclaimer = undefined;

/**
 * Processing type
 * @member {String} processingType
 */
VisaProduct.prototype.processingType = undefined;

/**
 * Minimum day that we can book for visa
 * @member {String} minTravelDate
 */
VisaProduct.prototype.minTravelDate = undefined;

/**
 * Additional service included with the product
 * @member {String} withServices
 */
VisaProduct.prototype.withServices = undefined;

/**
 * Required Document to process visa
 * @member {Array.<module:model/RequiredDocument>} requiredDocuments
 */
VisaProduct.prototype.requiredDocuments = undefined;

