/*
 * OnArrival Client API
 * OnArrival API service documentation
 *
 * OpenAPI spec version: v1.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.34
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from '../ApiClient';
import {Member} from './Member';
import {Trip} from './Trip';

/**
 * The VisaRequest model module.
 * @module model/VisaRequest
 * @version v1.0
 */
export class VisaRequest {
  /**
   * Constructs a new <code>VisaRequest</code>.
   * @alias module:model/VisaRequest
   * @class
   * @param requestedProducts {Array.<String>} product codes has to be passed which was returned in discover visa API
   * @param trip {module:model/Trip} 
   * @param members {Array.<module:model/Member>} Details of person to whom the visa is to be booked
   */
  constructor(requestedProducts, trip, members) {
    this.requestedProducts = requestedProducts;
    this.trip = trip;
    this.members = members;
  }

  /**
   * Constructs a <code>VisaRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/VisaRequest} obj Optional instance to populate.
   * @return {module:model/VisaRequest} The populated <code>VisaRequest</code> instance.
   */
  static constructFromObject(data, obj) {
    if (data) {
      obj = obj || new VisaRequest();
      if (data.hasOwnProperty('requestedProducts'))
        obj.requestedProducts = ApiClient.convertToType(data['requestedProducts'], ['String']);
      if (data.hasOwnProperty('ancillaryType'))
        obj.ancillaryType = ApiClient.convertToType(data['ancillaryType'], 'String');
      if (data.hasOwnProperty('trip'))
        obj.trip = Trip.constructFromObject(data['trip']);
      if (data.hasOwnProperty('members'))
        obj.members = ApiClient.convertToType(data['members'], [Member]);
      if (data.hasOwnProperty('status'))
        obj.status = ApiClient.convertToType(data['status'], 'String');
      if (data.hasOwnProperty('orderStatus'))
        obj.orderStatus = ApiClient.convertToType(data['orderStatus'], 'String');
    }
    return obj;
  }
}

/**
 * product codes has to be passed which was returned in discover visa API
 * @member {Array.<String>} requestedProducts
 */
VisaRequest.prototype.requestedProducts = undefined;

/**
 * Allowed values for the <code>ancillaryType</code> property.
 * @enum {String}
 * @readonly
 */
VisaRequest.AncillaryTypeEnum = {
  /**
   * value: "INSURANCE"
   * @const
   */
  INSURANCE: "INSURANCE",

  /**
   * value: "CAB"
   * @const
   */
  CAB: "CAB",

  /**
   * value: "VISA"
   * @const
   */
  VISA: "VISA",

  /**
   * value: "GROUND"
   * @const
   */
  GROUND: "GROUND",

  /**
   * value: "EVISA"
   * @const
   */
  EVISA: "EVISA",

  /**
   * value: "DATA"
   * @const
   */
  DATA: "DATA"
};
/**
 * @member {module:model/VisaRequest.AncillaryTypeEnum} ancillaryType
 */
VisaRequest.prototype.ancillaryType = undefined;

/**
 * @member {module:model/Trip} trip
 */
VisaRequest.prototype.trip = undefined;

/**
 * Details of person to whom the visa is to be booked
 * @member {Array.<module:model/Member>} members
 */
VisaRequest.prototype.members = undefined;

/**
 * @member {String} status
 */
VisaRequest.prototype.status = undefined;

/**
 * @member {String} orderStatus
 */
VisaRequest.prototype.orderStatus = undefined;

